<script setup lang="ts">
import { getProducts } from "../services/productService";
import { reactive } from "vue";
import { ProductInterface } from "../interfaces/product.interface";
defineProps<{ msg: string }>();
const columns = [
  {
    title: "ID",
    dataIndex: "id",
    key: "id",
  },
  {
    title: "Title",
    dataIndex: "title",
    key: "title",
  },
  {
    title: "Description",
    dataIndex: "bodyHtml",
    key: "bodyHtml",
  },
  {
    title: "Image",
    dataIndex: "image",
    key: "image",
  },
  {
    title: "Published",
    dataIndex: "publishedScope",
    key: "publishedScope",
  },
  {
    title: "Status",
    dataIndex: "status",
    key: "status",
  },
];

const form = reactive<{ products: ProductInterface[] }>({
  products: [],
});

const getProductsService = async () => {
  const products = await getProducts();
  form.products = products;
};

getProductsService();
</script>

<template>
  <a-table :dataSource="form.products" :columns="columns">
    <template #bodyCell="{ column, text }">
      <template v-if="column.dataIndex === 'bodyHtml'">
        <div v-html="text"></div>
      </template>
      <template v-if="column.dataIndex === 'image'">
        <a-image
          :width="100"
          :height="100"
          :src="text.src"
        />
      </template>
    </template>
  </a-table>
</template>

<style scoped>
.read-the-docs {
  color: #888;
}
</style>
